Exponential 6.0.13 Exponential Enterprise Open Source CMS - PHP Class Reference

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
eZWorkflow Class Reference
Inheritance diagram for eZWorkflow:

## Public Member Functions
| removeThis ( $remove_childs=false)
| store ( $store_childs=false)
| storeDefined ( $store_childs=false)
| setVersion ( $version, $set_childs=false)
| isAllowed ( $moduleName, $functionName, $connectType)
| fetchEventIndexed ( $index)
| fetchEvents ( $asObject=true, $version=false)
| fetchEventCount ( $version=false)
| creator ()
| modifier ()
| ingroupList ()
| ingroupIDList ()
| groupList ()
| workflowType ()
| cleanupWorkFlowProcess ()
Public Member Functions inherited from eZPersistentObject
| __construct ( $row=null)
| eZPersistentObject ( $row=null)
| fill ( $row)
| remove ( $conditions=null, $extraConditions=null)
| sync ( $fieldFilters=null)
| attributes ()
| hasAttribute ( $attr)
| attribute ( $attr, $noFunction=false)
| setAttribute ( $attr, $val)
| hasDirtyData ()
| setHasDirtyData ( $hasDirtyData)

## Static Public Member Functions
static | definition ()
static | statusName ( $status)
static | create ( $user_id)
static | setIsEnabled ( $enabled, $id, $version=0)
static | removeWorkflow ( $id, $version)
static | removeTemporary ()
static | removeEvents ( $events=false, $id=false, $version=false)
static | adjustEventPlacements ( $events)
static | fetch ( $id, $asObject=true, $version=0)
static | fetchLimited ( $moduleName, $functionName, $connectType)
static | fetchList ( $version=0, $enabled=1, $asObject=true)
static | fetchListCount ( $version=0, $enabled=1)
static | fetchEventsByWorkflowID ( $id, $asObject=true, $version=0)
static | fetchEventCountByWorkflowID ( $id, $version=0)
static | statusNameMap ()
Static Public Member Functions inherited from eZPersistentObject
static | replaceFieldsWithShortNames (eZDBInterface $db, array $fieldDefs, &$fields)
static | count ( $def, $conds=null, $field=null)
static | fetchObject ( $def, $field_filters, $conds, $asObject=true, $grouping=null, $custom_fields=null)
static | removeObject ( $def, $conditions=null, $extraConditions=null)
static | storeObject ( $obj, $fieldFilters=null)
static | conditionText ( $conditions)
static | conditionTextByRow ( $conditions, $row)
static | fetchObjectList ( $def, $field_filters=null, $conds=null, $sorts=null, $limit=null, $asObject=true, $grouping=false, $custom_fields=null, $custom_tables=null, $custom_conds=null)
static | handleRows ( $rows, $class_name, $asObject)
static | swapRow ( $table, $keys, $order_id, $rows, $id1, $id2)
static | newObjectOrder ( $def, $orderField, $conditions)
static | reorderObject ( $def, $orderField, $conditions, $down=true)
static | escapeArray ( $array)
static | updateObjectList ( $parameters)
static | getShortAttributeName ( $db, $def, $attrName)

## Public Attributes
const | STATUS_NONE = 0
const | STATUS_BUSY = 1
const | STATUS_DONE = 2
const | STATUS_FAILED = 3
const | STATUS_DEFERRED_TO_CRON = 4
const | STATUS_CANCELLED = 5
const | STATUS_FETCH_TEMPLATE = 6
const | STATUS_REDIRECT = 7
const | STATUS_RESET = 8
const | STATUS_WAITING_PARENT = 9
const | STATUS_FETCH_TEMPLATE_REPEAT = 10
| $ID
| $Name
| $WorkflowTypeString
| $Version
| $IsEnabled
| $CreatorID
| $ModifierID
| $Created
| $Modified
| $InGroups
| $InGroupIDs
| $AllGroups
Public Attributes inherited from eZPersistentObject
| $PersistentDataDirty
| $ID
| $ContentObjectID
| $SectionID
| $OwnerID
| $ClassID
| $Published
| $Modified
| $CurrentVersion
| $Status
| $RemoteID
| $LanguageMask
| $InitialLanguageID
| $NodeID
| $ParentNodeID
| $MainNodeID
| $ContentObjectVersion
| $ContentObjectIsPublished
| $Depth
| $SortField
| $SortOrder
| $Priority
| $ModifiedSubNode
| $PathString
| $PathIdentificationString
| $IsHidden
| $IsInvisible
| $UserID
| $Name
| $Locale
| $Identifier
| $NavigationPartIdentifier
| $SerializedDescriptionList
| $URLAliasName
| $AlwaysAvailable
| $CanTranslate
| $DataInt1
| $DataInt2
| $DataInt3
| $DataInt4
| $DataFloat1
| $DataFloat2
| $DataFloat3
| $DataFloat4
| $DataText1
| $DataText2
| $DataText3
| $DataText4
| $DataText5
| $SerializedDataText
| $Category
| $PolicyID
| $Values
| $Created
| $CurrencyCode
| $ProductCollectionID
| $ItemCount
| $Price
| $IsVATIncluded
| $VATValue
| $DiscountValue
| $Email
| $IsTemporary
| $IsArchived
| $IsActive
| $OrderID
| $ModifierID
| $Code
| $Symbol
| $AutoRateValue
| $CustomRateValue
| $RateFactor
| $Main
| $MementoKey
| $MainKey
| $WorkflowEventPos
| $LanguageID
| $ContentObjectStateGroupID
| $contentobject_attribute_id
| $contentobject_id
| $rating
| $rating_count
| $rating_average

## Additional Inherited Members
Static Protected Member Functions inherited from eZPersistentObject
static | replaceFieldsWithLongNames (eZDBInterface $db, array $fieldDefs, &$fields)

## Detailed Description

! eZKernel The class eZWorkflow does

Definition at line 17 of file ezworkflow.php.

## Member Function Documentation

## ◆ adjustEventPlacements()

static eZWorkflow::adjustEventPlacements | ( |  | $events | ) |
| static

Definition at line 218 of file ezworkflow.php.

## ◆ cleanupWorkFlowProcess()

eZWorkflow::cleanupWorkFlowProcess | ( |  | ) |

Note
  Transaction unsafe. If you call several transaction unsafe methods you must enclose the calls within a db transaction; thus within db->begin and db->commit.

Definition at line 517 of file ezworkflow.php.

References eZPersistentObject\attribute(), fetchEvents(), and eZDB\instance().

## ◆ create()

static eZWorkflow::create | ( |  | $user_id | ) |
| static

Definition at line 100 of file ezworkflow.php.

## ◆ creator()

eZWorkflow::creator | ( |  | ) |

Definition at line 460 of file ezworkflow.php.

References eZUser\fetch().

## ◆ definition()

static eZWorkflow::definition | ( |  | ) |
| static

Returns the definition for the object, the default implementation is to return an empty array. It's upto each inheriting class to return a proper definition array.

The definition array is an associative array consists of these keys:

- fields: an associative array of fields which defines which database field (the key) is to fetched and how they map to object member variables (the value).
- keys: an array of fields which is used for uniquely identifying the object in the table.
- function_attributes: an associative array of attributes which maps to member functions, used for fetching data with functions.
- set_functions: an associative array of attributes which maps to member functions, used for setting data with functions.
- increment_key: the field which is incremented on table inserts.
- class_name: the classname which is used for instantiating new objecs when fetching from the database.
- sort: an associative array which defines the default sorting of lists, the key is the table field while the value is the sorting method which is either 'asc' or 'desc'.
- name: the name of the database table

Example: `public static function definition() { return array( "fields" => array( "id" => "ID", "version" => "Version", "name" => "Name" ), "keys" => array( "id", "version" ), "function_attributes" => array( "current" => "currentVersion", "class_name" => "className" ), "increment_key" => "id", "class_name" => "eZContentClass", "sort" => array( "id" => "asc" ), "name" => "ezcontentclass" ); }`

Returns
  array

Reimplemented from eZPersistentObject.

Definition at line 31 of file ezworkflow.php.

Referenced by fetch(), fetchList(), fetchListCount(), removeWorkflow(), and setIsEnabled().

## ◆ fetch()

static eZWorkflow::fetch | ( |  | $id,
|  |  | $asObject = `true`,
|  |  | $version = `0`
| ) |  |
| static

Definition at line 302 of file ezworkflow.php.

References definition(), and eZPersistentObject\fetchObject().

Referenced by eZMultiplexerType\execute(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and eZWorkflowProcess\workflow().

## ◆ fetchEventCount()

eZWorkflow::fetchEventCount | ( |  | $version = `false` | ) |

Definition at line 426 of file ezworkflow.php.

References $Version, eZWorkflowEvent\definition(), and eZPersistentObject\fetchObjectList().

## ◆ fetchEventCountByWorkflowID()

static eZWorkflow::fetchEventCountByWorkflowID | ( |  | $id,
|  |  | $version = `0`
| ) |  |
| static

Definition at line 445 of file ezworkflow.php.

References eZWorkflowEvent\definition(), and eZPersistentObject\fetchObjectList().

## ◆ fetchEventIndexed()

eZWorkflow::fetchEventIndexed | ( |  | $index | ) |

Definition at line 389 of file ezworkflow.php.

References $ID, eZPersistentObject\count(), eZWorkflowEvent\definition(), eZPersistentObject\fetchObjectList(), and eZDebugSetting\writeDebug().

## ◆ fetchEvents()

eZWorkflow::fetchEvents | ( |  | $asObject = `true`,
|  |  | $version = `false`
| ) |  |

Definition at line 408 of file ezworkflow.php.

References $Version, and eZWorkflowEvent\fetchFilteredList().

Referenced by cleanupWorkFlowProcess(), isAllowed(), setVersion(), store(), and storeDefined().

## ◆ fetchEventsByWorkflowID()

static eZWorkflow::fetchEventsByWorkflowID | ( |  | $id,
|  |  | $asObject = `true`,
|  |  | $version = `0`
| ) |  |
| static

Definition at line 419 of file ezworkflow.php.

References eZWorkflowEvent\fetchFilteredList().

## ◆ fetchLimited()

static eZWorkflow::fetchLimited | ( |  | $moduleName,
|  |  | $functionName,
|  |  | $connectType
| ) |  |
| static

Fetch workflows based on module, function and connection type

Parameters

  $moduleName | module name
  $functionName | function name
  $connectType | connection type

Returns
  array of allowed workflows limited by trigger

Definition at line 321 of file ezworkflow.php.

References fetchList(), and isAllowed().

Referenced by eZTrigger\fetchAllowedWorkflows().

## ◆ fetchList()

static eZWorkflow::fetchList | ( |  | $version = `0`,
|  |  | $enabled = `1`,
|  |  | $asObject = `true`
| ) |  |
| static

Definition at line 364 of file ezworkflow.php.

References definition(), and eZPersistentObject\fetchObjectList().

Referenced by eZMultiplexerType\attribute(), fetchLimited(), and removeTemporary().

## ◆ fetchListCount()

static eZWorkflow::fetchListCount | ( |  | $version = `0`,
|  |  | $enabled = `1`
| ) |  |
| static

Definition at line 374 of file ezworkflow.php.

References definition(), and eZPersistentObject\fetchObjectList().

## ◆ groupList()

eZWorkflow::groupList | ( |  | ) |

Definition at line 502 of file ezworkflow.php.

References $AllGroups, and eZWorkflowGroup\fetchList().

## ◆ ingroupIDList()

eZWorkflow::ingroupIDList | ( |  | ) |

Definition at line 488 of file ezworkflow.php.

References $InGroupIDs, eZPersistentObject\attribute(), and eZWorkflowGroupLink\fetchGroupList().

## ◆ ingroupList()

eZWorkflow::ingroupList | ( |  | ) |

Definition at line 480 of file ezworkflow.php.

References $InGroups, eZPersistentObject\attribute(), and eZWorkflowGroupLink\fetchGroupList().

## ◆ isAllowed()

eZWorkflow::isAllowed | ( |  | $moduleName,
|  |  | $functionName,
|  |  | $connectType
| ) |  |

Check if a trigger specified trigger is allowed to use with this workflow

Parameters

  $moduleName | module name
  $functionName | function name
  $connectType | connection type

Returns
  true if allowed, false if not.

Definition at line 348 of file ezworkflow.php.

References fetchEvents().

Referenced by fetchLimited().

## ◆ modifier()

eZWorkflow::modifier | ( |  | ) |

Definition at line 470 of file ezworkflow.php.

References eZUser\fetch().

## ◆ removeEvents()

static eZWorkflow::removeEvents | ( |  | $events = `false`,
|  |  | $id = `false`,
|  |  | $version = `false`
| ) |  |
| static

Note
  Transaction unsafe. If you call several transaction unsafe methods you must enclose the calls within a db transaction; thus within db->begin and db->commit.

Definition at line 190 of file ezworkflow.php.

References eZWorkflowEvent\definition(), eZDB\instance(), and eZPersistentObject\removeObject().

## ◆ removeTemporary()

static eZWorkflow::removeTemporary | ( |  | ) |
| static

Removes all temporary versions.

Note
  Transaction unsafe. If you call several transaction unsafe methods you must enclose the calls within a db transaction; thus within db->begin and db->commit.

Definition at line 170 of file ezworkflow.php.

References eZWorkflowEvent\definition(), fetchList(), eZDB\instance(), and eZPersistentObject\removeObject().

## ◆ removeThis()

eZWorkflow::removeThis | ( |  | $remove_childs = `false` | ) |

Note
  Transaction unsafe. If you call several transaction unsafe methods you must enclose the calls within a db transaction; thus within db->begin and db->commit.

Definition at line 142 of file ezworkflow.php.

References eZWorkflowEvent\definition(), eZDB\instance(), and eZPersistentObject\removeObject().

## ◆ removeWorkflow()

static eZWorkflow::removeWorkflow | ( |  | $id,
|  |  | $version
| ) |  |
| static

Note
  Transaction unsafe. If you call several transaction unsafe methods you must enclose the calls within a db transaction; thus within db->begin and db->commit.

Definition at line 131 of file ezworkflow.php.

References definition(), and eZPersistentObject\removeObject().

## ◆ setIsEnabled()

static eZWorkflow::setIsEnabled | ( |  | $enabled,
|  |  | $id,
|  |  | $version = `0`
| ) |  |
| static

Definition at line 116 of file ezworkflow.php.

References definition(), and eZPersistentObject\updateObjectList().

## ◆ setVersion()

eZWorkflow::setVersion | ( |  | $version,
|  |  | $set_childs = `false`
| ) |  |

Definition at line 282 of file ezworkflow.php.

References fetchEvents(), and eZPersistentObject\setAttribute().

## ◆ statusName()

static eZWorkflow::statusName | ( |  | $status | ) |
| static

Definition at line 92 of file ezworkflow.php.

References statusNameMap().

## ◆ statusNameMap()

static eZWorkflow::statusNameMap | ( |  | ) |
| static

Get status name map.

Returns
  array Status name map.

Definition at line 546 of file ezworkflow.php.

References STATUS_BUSY, STATUS_CANCELLED, STATUS_DEFERRED_TO_CRON, STATUS_DONE, STATUS_FAILED, STATUS_FETCH_TEMPLATE, STATUS_NONE, STATUS_REDIRECT, STATUS_RESET, and ezpI18n\tr().

Referenced by statusName().

## ◆ store()

eZWorkflow::store | ( |  | $store_childs = `false` | ) |

Note
  Transaction unsafe. If you call several transaction unsafe methods you must enclose the calls within a db transaction; thus within db->begin and db->commit.

Reimplemented from eZPersistentObject.

Definition at line 233 of file ezworkflow.php.

References fetchEvents(), and eZDB\instance().

## ◆ storeDefined()

eZWorkflow::storeDefined | ( |  | $store_childs = `false` | ) |

Note
  Transaction unsafe. If you call several transaction unsafe methods you must enclose the calls within a db transaction; thus within db->begin and db->commit.

Definition at line 259 of file ezworkflow.php.

References fetchEvents(), and eZDB\instance().

## ◆ workflowType()

eZWorkflow::workflowType | ( |  | ) |

Definition at line 508 of file ezworkflow.php.

References eZWorkflowType\createType().

## Member Data Documentation

## ◆ $AllGroups

eZWorkflow::$AllGroups

Definition at line 571 of file ezworkflow.php.

Referenced by groupList().

## ◆ $Created

eZWorkflow::$Created

Definition at line 567 of file ezworkflow.php.

## ◆ $CreatorID

eZWorkflow::$CreatorID

Definition at line 565 of file ezworkflow.php.

## ◆ $ID

eZWorkflow::$ID

Definition at line 560 of file ezworkflow.php.

Referenced by fetchEventIndexed().

## ◆ $InGroupIDs

eZWorkflow::$InGroupIDs

Definition at line 570 of file ezworkflow.php.

Referenced by ingroupIDList().

## ◆ $InGroups

eZWorkflow::$InGroups

Definition at line 569 of file ezworkflow.php.

Referenced by ingroupList().

## ◆ $IsEnabled

eZWorkflow::$IsEnabled

Definition at line 564 of file ezworkflow.php.

## ◆ $Modified

eZWorkflow::$Modified

Definition at line 568 of file ezworkflow.php.

## ◆ $ModifierID

eZWorkflow::$ModifierID

Definition at line 566 of file ezworkflow.php.

## ◆ $Name

eZWorkflow::$Name

Definition at line 561 of file ezworkflow.php.

## ◆ $Version

eZWorkflow::$Version

Definition at line 563 of file ezworkflow.php.

Referenced by fetchEventCount(), and fetchEvents().

## ◆ $WorkflowTypeString

eZWorkflow::$WorkflowTypeString

Definition at line 562 of file ezworkflow.php.

## ◆ STATUS_BUSY

const eZWorkflow::STATUS_BUSY = 1

Definition at line 20 of file ezworkflow.php.

Referenced by eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_CANCELLED

const eZWorkflow::STATUS_CANCELLED = 5

Definition at line 24 of file ezworkflow.php.

Referenced by eZMultiplexerType\execute(), eZWorkflowProcess\run(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_DEFERRED_TO_CRON

const eZWorkflow::STATUS_DEFERRED_TO_CRON = 4

Definition at line 23 of file ezworkflow.php.

Referenced by eZApproveType\execute(), eZMultiplexerType\execute(), eZWorkflowProcess\run(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_DONE

const eZWorkflow::STATUS_DONE = 2

Definition at line 21 of file ezworkflow.php.

Referenced by eZMultiplexerType\execute(), eZWorkflowProcess\run(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_FAILED

const eZWorkflow::STATUS_FAILED = 3

Definition at line 22 of file ezworkflow.php.

Referenced by eZMultiplexerType\execute(), eZWorkflowProcess\run(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_FETCH_TEMPLATE

const eZWorkflow::STATUS_FETCH_TEMPLATE = 6

Definition at line 25 of file ezworkflow.php.

Referenced by eZMultiplexerType\execute(), eZWorkflowProcess\run(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_FETCH_TEMPLATE_REPEAT

const eZWorkflow::STATUS_FETCH_TEMPLATE_REPEAT = 10

Definition at line 29 of file ezworkflow.php.

Referenced by eZMultiplexerType\execute(), eZWorkflowProcess\run(), eZTrigger\runTrigger(), and eZTrigger\runWorkflow().

## ◆ STATUS_NONE

const eZWorkflow::STATUS_NONE = 0

Definition at line 19 of file ezworkflow.php.

Referenced by eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_REDIRECT

const eZWorkflow::STATUS_REDIRECT = 7

Definition at line 26 of file ezworkflow.php.

Referenced by eZMultiplexerType\execute(), eZWorkflowProcess\run(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_RESET

const eZWorkflow::STATUS_RESET = 8

Definition at line 27 of file ezworkflow.php.

Referenced by eZWorkflowProcess\run(), eZTrigger\runTrigger(), eZTrigger\runWorkflow(), and statusNameMap().

## ◆ STATUS_WAITING_PARENT

const eZWorkflow::STATUS_WAITING_PARENT = 9

Definition at line 28 of file ezworkflow.php.

Referenced by eZMultiplexerType\execute().

The documentation for this class was generated from the following file:

- ezworkflow.php

Copyright © 1998 – 2026 7x. All rights reserved. Licensed under the GNU GPLv2+.